#Made by M7md TG ;)

# Starting build
 
execute @e[type=worldedit:pos1,tag=we_ready,tag=we_fill] ~~~ function we/high-end/fill
execute @e[type=worldedit:pos1,tag=we_ready,tag=we_hollow] ~~~ function we/high-end/hollow
execute @e[type=worldedit:pos1,tag=we_ready,tag=we_outline] ~~~ function we/high-end/outline
execute @e[type=worldedit:pos1,tag=we_ready,tag=we_wall] ~~~ function we/high-end/wall
execute @e[type=worldedit:pos1,tag=we_ready,tag=we_clear] ~~~ function we/high-end/clear
execute @e[type=worldedit:pos1,tag=we_ready,tag=we_sphere,tag=!we_sphere_started] ~~~ scoreboard players operation @s we_s_radius = @a[tag=we_host] we_s_radius
execute @e[type=worldedit:pos1,tag=we_ready,tag=we_sphere,tag=!we_sphere_started] ~~~ tag @s add we_sphere_started
execute @e[type=worldedit:pos1,tag=we_ready,tag=we_sphere_started] ~~~ function we/high-end/sphere
 
#Scoreboards
 
scoreboard objectives add we_s_yrot dummy "Sphere-Y-Rotation"
scoreboard objectives add we_s_xrot dummy "Sphere-X-Rotation"
scoreboard objectives add we_s_radius dummy "Sphere-Radius"
scoreboard objectives add we_b_size dummy "Brush-Radius"
scoreboard objectives add we_settings dummy "Settings"
scoreboard objectives add we_strength dummy "WorldEdit-Strength"
scoreboard objectives add we_build_mode dummy "Build-Mode"
scoreboard objectives add we_fill_mode dummy "Fill-Mode"
scoreboard objectives add we_b_page dummy "Current-Book-Page"
#calculations 
scoreboard objectives add we_x_scale dummy "X-Scale"
scoreboard objectives add we_y_scale dummy "Y-Scale"
scoreboard objectives add we_z_scale dummy "Z-Scale"
scoreboard objectives add we_x_score dummy "X-Score"
scoreboard objectives add we_y_score dummy "Y-Score"
scoreboard objectives add we_z_score dummy "Z-Score"
scoreboard objectives add we_cph1 dummy "Calculation-Placeholder-1"
scoreboard objectives add we_cph2 dummy "Calculation-Placeholder-2"
scoreboard objectives add we_blocks_count dummy "Blocks-Count"

scoreboard players set @a[tag=we_host,tag=!we_scoreboards_setup] we_strength 1
scoreboard players set @a[tag=we_host,tag=!we_scoreboards_setup] we_s_radius 1
scoreboard players set @a[tag=we_host,tag=!we_scoreboards_setup] we_b_size 0
scoreboard players set @a[tag=we_host,tag=!we_scoreboards_setup] we_settings 1
scoreboard players set @a[tag=we_host,tag=!we_scoreboards_setup] we_build_mode 1
scoreboard players set @a[tag=we_host,tag=!we_scoreboards_setup] we_fill_mode 1
scoreboard players set @a[tag=we_host,tag=!we_scoreboards_setup] we_b_page 1
tag @a[tag=we_host] add we_scoreboards_setup

#Cycling scores

scoreboard players set @a[scores={we_strength=4..}] we_strength 1
scoreboard players set @a[scores={we_s_radius=101..}] we_s_radius 1
scoreboard players set @a[scores={we_b_size=5..}] we_b_size 0
scoreboard players set @a[scores={we_settings=5..}] we_settings 1
scoreboard players set @a[scores={we_build_mode=6..}] we_build_mode 1
scoreboard players set @a[scores={we_fill_mode=4..}] we_fill_mode 1
scoreboard players set @a[scores={we_b_page=8..}] we_b_page 1


# Only host has worldedit
 
clear @a[tag=!we_host] worldedit:we_brush
clear @a[tag=!we_host] worldedit:we_eraser
clear @a[tag=!we_host] worldedit:we_settings
clear @a[tag=!we_host] worldedit:we_build_menu
clear @a[tag=!we_host] worldedit:we_book
clear @a worldedit:we_enable
clear @a[tag=!we_host] worldedit:we_disable
clear @a worldedit:pos1_spawn_egg
clear @a worldedit:pos2_spawn_egg
clear @a[tag=!we_host] worldedit:pos1_spawner_spawn_egg
clear @a[tag=!we_host] worldedit:pos2_spawner_spawn_egg
 
# Only 1 from each pos
execute @e[type=worldedit:pos1_spawner] ~~~ summon worldedit:pos1 ~~-0.5~
kill @e[type=worldedit:pos1_spawner]
execute @e[type=worldedit:pos2_spawner] ~~~ summon worldedit:pos2 ~~-0.5~
kill @e[type=worldedit:pos2_spawner]
execute @e[type=worldedit:pos1,tag=!we_ready] ~ ~ ~ kill @e[type=worldedit:pos1,tag=we_ready]
execute @e[type=worldedit:pos2,tag=!we_ready] ~ ~ ~ kill @e[type=worldedit:pos2,tag=we_ready]
 
execute @e[type=worldedit:pos1,tag=!we_ready] ~~~ tp ~~~ 0 90
execute @e[type=worldedit:pos1,tag=!we_ready] ~ ~ ~ structure save we_selection ~~~ ~~~ false memory true
execute @e[type=worldedit:pos2,tag=!we_ready] ~ ~ ~ structure save we_selection2 ~~~ ~~~ false memory true
execute @e[type=worldedit:pos1,tag=!we_ready] ~~~ tag @s add we_ready
execute @e[type=worldedit:pos2,tag=!we_ready] ~~~ tag @s add we_ready
 
# Brush cursor
 
execute @a[tag=we_brush_cursor,tag=we_host] ~~1.4~ tp @e[type=worldedit:cursor] ^0.01^^10 facing @s
 
# Ui
 
execute @a[tag=we_host,tag=we_build_menu] ~~~ function we/misc/build_menu/build_menu_ui
execute @a[tag=we_host,tag=we_settings] ~~~ function we/misc/settings/settings_ui
execute @a[tag=we_host,tag=we_book] ~~~ function we/misc/book/book_ui
 
# not under condition operations
 
execute @e[type=worldedit:pos1,tag=we_tested_bad] ~~~ tellraw @a[tag=we_host] {"rawtext":[{"text":"<WorldEdit> Area too large: "},{"score":{"name":"@e[type=worldedit:pos1]","objective":"we_x_scale"}},{"text":"x"},{"score":{"name":"@e[type=worldedit:pos1]","objective":"we_y_scale"}},{"text":"x"},{"score":{"name":"@e[type=worldedit:pos1]","objective":"we_z_scale"}}]}
execute @e[type=worldedit:pos1,tag=we_tested_bad] ~~~ execute @a[tag=we_host] ~~~ playsound item.trident.return @s ~~~ 0.5 0.8
execute @e[type=worldedit:pos1,tag=we_tested_bad] ~~~ execute @a[tag=we_host] ~~~ playsound random.hurt @s ~~~ 0.3 1
tag @e[type=worldedit:pos1,tag=we_tested_bad] remove we_fill
tag @e[type=worldedit:pos1,tag=we_tested_bad] remove we_outline
tag @e[type=worldedit:pos1,tag=we_tested_bad] remove we_hollow
tag @e[type=worldedit:pos1,tag=we_tested_bad] remove we_clear
tag @e[type=worldedit:pos1,tag=we_tested_bad] remove we_measured
tag @e[type=worldedit:pos1,tag=we_tested_bad] remove we_tested_bad

execute @e[type=worldedit:pos1,tag=we_found_bad_surface] ~~~ tellraw @a[tag=we_host] {"rawtext":[{"text":"<WorldEdit> Area too large: "},{"score":{"name":"@e[type=worldedit:pos1]","objective":"we_x_scale"}},{"text":"x"},{"score":{"name":"@e[type=worldedit:pos1]","objective":"we_y_scale"}},{"text":"x"},{"score":{"name":"@e[type=worldedit:pos1]","objective":"we_z_scale"}}]}
execute @e[type=worldedit:pos1,tag=we_found_bad_surface] ~~~ execute @a[tag=we_host] ~~~ playsound item.trident.return @s ~~~ 0.5 0.8
execute @e[type=worldedit:pos1,tag=we_found_bad_surface] ~~~ execute @a[tag=we_host] ~~~ playsound random.hurt @s ~~~ 0.3 1
tag @e[type=worldedit:pos1,tag=we_found_bad_surface] remove we_fill
tag @e[type=worldedit:pos1,tag=we_found_bad_surface] remove we_outline
tag @e[type=worldedit:pos1,tag=we_found_bad_surface] remove we_hollow
tag @e[type=worldedit:pos1,tag=we_found_bad_surface] remove we_clear
tag @e[type=worldedit:pos1,tag=we_found_bad_surface] remove we_measured
tag @e[type=worldedit:pos1,tag=we_found_bad_surface] remove we_found_bad_surface
